<script lang="ts" setup>
import ConfirmDialog from "@/components/ConfirmDialog.vue";
import { useCategoryStore } from "@/stores/category";
import { useProductStore } from "@/stores/product";
import { onMounted, ref } from "vue";
import ProductDialog from "./ProductDialog.vue";

const productStore = useProductStore();
const categoryStore = useCategoryStore();

const confirmDlg = ref();
const backendURL = import.meta.env.VITE_BACKEND_URL;
onMounted(async () => {
  // console.log(import.meta.env.VITE_BACKEND_URL);
  // await productStore.getProducts();
  await categoryStore.getCategories();
  await productStore.getProductsByCategory(productStore.category);
});

const deleteProduct = async (id: number) => {
  try {
    await confirmDlg.value.openDialog(
      "Please Confirm",
      `คุณต้องการลบ ID ${id} หรือไม่`
    );
    await productStore.deleteProduct(id);
  } catch (e) {
    /* empty */
  }
};
</script>
<template>
  <ProductDialog></ProductDialog>
  <v-btn @click="productStore.dialog = true">Add New</v-btn>
  <div>{{ productStore.category }}</div>
  <v-tabs v-model="productStore.category" bg-color="green">
    <v-tab
      v-for="item of categoryStore.categories"
      :value="item.id"
      :key="item.id"
      >{{ item.name }}</v-tab
    >
  </v-tabs>
  <v-table>
    <thead>
      <tr>
        <th>ID</th>
        <th>Image</th>
        <th>Name</th>
        <th>Price</th>
        <th>Operations</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="item of productStore.products" :key="item.id">
        <td>{{ item.id }}</td>
        <td>
          <v-img
            :src="`${backendURL}/products/image/${item.image}`"
            height="128px"
          ></v-img>
          <!-- :src="`http://localhost:3000/products/image/${item.image}`" -->
        </td>
        <td>{{ item.name }}</td>
        <td>{{ item.price }}</td>
        <td>
          <v-btn class="mr-5" @click="productStore.editProduct(item)"
            >Edit</v-btn
          ><v-btn @click="deleteProduct(item.id!)">Delete</v-btn>
        </td>
      </tr>
    </tbody>
  </v-table>
  <ConfirmDialog ref="confirmDlg"></ConfirmDialog>
</template>
